GHSA-hjg4-8q5f-x6fm

Source
https://github.com/github/advisory-database/blob/main/advisories/github-reviewed/2021/05/GHSA-hjg4-8q5f-x6fm/GHSA-hjg4-8q5f-x6fm.json
Aliases
Published
2021-05-05T19:49:02Z
Modified
2022-08-15T09:09:47.780360Z
Details

Impact

There is a possible information disclosure / unintended method execution vulnerability in Action Pack when using the redirect_to or polymorphic_url helper with untrusted user input.

Vulnerable code will look like this.

redirect_to(params[:some_param])

All users running an affected release should either upgrade or use one of the workarounds immediately.

Releases

The FIXED releases are available at the normal locations.

Workarounds

To work around this problem, it is recommended to use an allow list for valid parameters passed from the user. For example,

private def check(param)
  case param
  when "valid"
    param
  else
    "/"
  end
end

def index
  redirect_to(check(params[:some_param]))
end

Or force the user input to be cast to a string like this,

def index
  redirect_to(params[:some_param].to_s)
end

Patches

To aid users who aren't able to upgrade immediately we have provided patches for the two supported release series. They are in git-am format and consist of a single changeset.

  • 5-2-information-disclosure.patch - Patch for 5.2 series
  • 6-0-information-disclosure.patch - Patch for 6.0 series
  • 6-1-information-disclosure.patch - Patch for 6.1 series

Please note that only the 5.2, 6.0, and 6.1 series are supported at present. Users of earlier unsupported releases are advised to upgrade as soon as possible as we cannot guarantee the continued availability of security fixes for unsupported releases.

Credits

Thanks to Benoit Côté-Jodoin from Shopify for reporting this.

References

Affected packages

RubyGems / actionpack

actionpack

Affected ranges

Type
ECOSYSTEM
Events
Introduced
6.0.0
Fixed
6.0.3.7

Affected versions

6.*

6.0.0
6.0.1
6.0.1.rc1
6.0.2
6.0.2.1
6.0.2.2
6.0.2.rc1
6.0.2.rc2
6.0.3
6.0.3.1
6.0.3.2
6.0.3.3
6.0.3.4
6.0.3.5
6.0.3.6
6.0.3.rc1

Database specific

{
    "last_known_affected_version_range": "<= 6.0.3.6"
}

RubyGems / actionpack

actionpack

Affected ranges

Type
ECOSYSTEM
Events
Introduced
6.1.0
Fixed
6.1.3.2

Affected versions

6.*

6.1.0
6.1.1
6.1.2
6.1.2.1
6.1.3
6.1.3.1

Database specific

{
    "last_known_affected_version_range": "<= 6.1.3.1"
}

RubyGems / actionpack

actionpack

Affected ranges

Type
ECOSYSTEM
Events
Introduced
5.2.5
Fixed
5.2.6

Affected versions

5.*

5.2.5

RubyGems / actionpack

actionpack

Affected ranges

Type
ECOSYSTEM
Events
Introduced
2.0.0
Fixed
5.2.4.6

Affected versions

2.*

2.0.0
2.0.1
2.0.2
2.0.4
2.0.5
2.1.0
2.1.1
2.1.2
2.2.2
2.2.3
2.3.10
2.3.11
2.3.12
2.3.14
2.3.15
2.3.16
2.3.17
2.3.18
2.3.2
2.3.3
2.3.4
2.3.5
2.3.6
2.3.7
2.3.8
2.3.8.pre1
2.3.9
2.3.9.pre

3.*

3.0.0
3.0.0.beta
3.0.0.beta2
3.0.0.beta3
3.0.0.beta4
3.0.0.rc
3.0.0.rc2
3.0.1
3.0.10
3.0.10.rc1
3.0.11
3.0.12
3.0.12.rc1
3.0.13
3.0.13.rc1
3.0.14
3.0.15
3.0.16
3.0.17
3.0.18
3.0.19
3.0.2
3.0.20
3.0.3
3.0.4
3.0.4.rc1
3.0.5
3.0.5.rc1
3.0.6
3.0.6.rc1
3.0.6.rc2
3.0.7
3.0.7.rc1
3.0.7.rc2
3.0.8
3.0.8.rc1
3.0.8.rc2
3.0.8.rc4
3.0.9
3.0.9.rc1
3.0.9.rc3
3.0.9.rc4
3.0.9.rc5
3.1.0
3.1.0.beta1
3.1.0.rc1
3.1.0.rc2
3.1.0.rc3
3.1.0.rc4
3.1.0.rc5
3.1.0.rc6
3.1.0.rc8
3.1.1
3.1.1.rc1
3.1.1.rc2
3.1.1.rc3
3.1.10
3.1.11
3.1.12
3.1.2
3.1.2.rc1
3.1.2.rc2
3.1.3
3.1.4
3.1.4.rc1
3.1.5
3.1.5.rc1
3.1.6
3.1.7
3.1.8
3.1.9
3.2.0
3.2.0.rc1
3.2.0.rc2
3.2.1
3.2.10
3.2.11
3.2.12
3.2.13
3.2.13.rc1
3.2.13.rc2
3.2.14
3.2.14.rc1
3.2.14.rc2
3.2.15
3.2.15.rc1
3.2.15.rc2
3.2.15.rc3
3.2.16
3.2.17
3.2.18
3.2.19
3.2.2
3.2.2.rc1
3.2.20
3.2.21
3.2.22
3.2.22.1
3.2.22.2
3.2.22.3
3.2.22.4
3.2.22.5
3.2.3
3.2.3.rc1
3.2.3.rc2
3.2.4
3.2.4.rc1
3.2.5
3.2.6
3.2.7
3.2.7.rc1
3.2.8
3.2.8.rc1
3.2.8.rc2
3.2.9
3.2.9.rc1
3.2.9.rc2
3.2.9.rc3

4.*

4.0.0
4.0.0.beta1
4.0.0.rc1
4.0.0.rc2
4.0.1
4.0.1.rc1
4.0.1.rc2
4.0.1.rc3
4.0.1.rc4
4.0.10
4.0.10.rc1
4.0.10.rc2
4.0.11
4.0.11.1
4.0.12
4.0.13
4.0.13.rc1
4.0.2
4.0.3
4.0.4
4.0.4.rc1
4.0.5
4.0.6
4.0.6.rc1
4.0.6.rc2
4.0.6.rc3
4.0.7
4.0.8
4.0.9
4.1.0
4.1.0.beta1
4.1.0.beta2
4.1.0.rc1
4.1.0.rc2
4.1.1
4.1.10
4.1.10.rc1
4.1.10.rc2
4.1.10.rc3
4.1.10.rc4
4.1.11
4.1.12
4.1.12.rc1
4.1.13
4.1.13.rc1
4.1.14
4.1.14.1
4.1.14.2
4.1.14.rc1
4.1.14.rc2
4.1.15
4.1.15.rc1
4.1.16
4.1.16.rc1
4.1.2
4.1.2.rc1
4.1.2.rc2
4.1.2.rc3
4.1.3
4.1.4
4.1.5
4.1.6
4.1.6.rc1
4.1.6.rc2
4.1.7
4.1.7.1
4.1.8
4.1.9
4.1.9.rc1
4.2.0
4.2.0.beta1
4.2.0.beta2
4.2.0.beta3
4.2.0.beta4
4.2.0.rc1
4.2.0.rc2
4.2.0.rc3
4.2.1
4.2.1.rc1
4.2.1.rc2
4.2.1.rc3
4.2.1.rc4
4.2.10
4.2.10.rc1
4.2.11
4.2.11.1
4.2.11.2
4.2.11.3
4.2.2
4.2.3
4.2.3.rc1
4.2.4
4.2.4.rc1
4.2.5
4.2.5.1
4.2.5.2
4.2.5.rc1
4.2.5.rc2
4.2.6
4.2.6.rc1
4.2.7
4.2.7.1
4.2.7.rc1
4.2.8
4.2.8.rc1
4.2.9
4.2.9.rc1
4.2.9.rc2

5.*

5.0.0
5.0.0.1
5.0.0.beta1
5.0.0.beta1.1
5.0.0.beta2
5.0.0.beta3
5.0.0.beta4
5.0.0.racecar1
5.0.0.rc1
5.0.0.rc2
5.0.1
5.0.1.rc1
5.0.1.rc2
5.0.2
5.0.2.rc1
5.0.3
5.0.4
5.0.4.rc1
5.0.5
5.0.5.rc1
5.0.5.rc2
5.0.6
5.0.6.rc1
5.0.7
5.0.7.1
5.0.7.2
5.1.0
5.1.0.beta1
5.1.0.rc1
5.1.0.rc2
5.1.1
5.1.2
5.1.2.rc1
5.1.3
5.1.3.rc1
5.1.3.rc2
5.1.3.rc3
5.1.4
5.1.4.rc1
5.1.5
5.1.5.rc1
5.1.6
5.1.6.1
5.1.6.2
5.1.7
5.1.7.rc1
5.2.0
5.2.0.beta1
5.2.0.beta2
5.2.0.rc1
5.2.0.rc2
5.2.1
5.2.1.1
5.2.1.rc1
5.2.2
5.2.2.1
5.2.2.rc1
5.2.3
5.2.3.rc1
5.2.4
5.2.4.1
5.2.4.2
5.2.4.3
5.2.4.4
5.2.4.5
5.2.4.rc1

Database specific

{
    "last_known_affected_version_range": "<= 5.2.4.5"
}